<?
// *MOOSTAT lib v1.16
// (c) 2002 by moolok.com
// contact me for any questions
// email: moo@level2000.de
// www.level2000.de/moo/moostat/


class mooStat {
	function mooStat ($name){
		if(!preg_match("/\bRTCW\b|\bQ3\b|\bHL\b|\bCS\b/i", $name)){
			die("ERROR in *MOOSTAT: <b>".$name."</b> not supported");
		}

		$this->GameName = $name;
		$this->Timeout = 5;
		$this->errmsg = '';
		$this->buffer_players = '';
		$this->buffer_status = '';
		$this->buffer_info = '';
		$this->buffer_rules = '';

		$this->PlayersList = array();
		$this->PlayersCount = 0;
		$this->RulesList = array();
		
		$this->getInfo = array();
	}

	function set_timeout ($time){
		$this->Timeout = $time;
	}
	
	function connect ($Host,$Port){
		// Half-Life, Counter-Strike, etc.
		if(preg_match("/\bHL\b|\bCS\b/i", $this->GameName)){
			$socket = fsockopen("udp://".gethostbyname($Host), $Port , $errno, $errstr , 3);
			@socket_set_timeout($socket, $this->Timeout);
			if($socket){
				fputs($socket, "\xff\xff\xff\xffinfo");
				fread($socket, 5);
				$SocStatus = socket_get_status($socket);
				$this->buffer_info = fread($socket, $SocStatus['unread_bytes']);
				
				fputs($socket, "\xff\xff\xff\xffplayers");
				fread($socket, 5);
				$SocStatus = socket_get_status($socket);
				$this->buffer_players = fread($socket, $SocStatus['unread_bytes']);
				
				fputs($socket, "\xff\xff\xff\xffrules");
				fread($socket, 7);
				$SocStatus = socket_get_status($socket);
				$this->buffer_rules = fread($socket, $SocStatus['unread_bytes']);
							
				fclose($socket);
				
				
				if($SocStatus["timed_out"]){
					$this->errmsg = "time out";
					return 0;
				}

				$this->buffer_info = preg_replace("/\x0D/", '', $this->buffer_info);
				$info_data = explode("\x00", $this->buffer_info);
				$this->getInfo["_ip"] = $info_data[0];
				$this->getInfo["_hostname"] = $info_data[1];
				$this->getInfo["_map"] = $info_data[2];
				$this->getInfo["_game"] = $info_data[3];
				$this->getInfo["_gamename"] = $info_data[4];
				$this->getInfo["_players"] = ord(substr($info_data[5], -3, 1));
				$this->getInfo["_maxplayers"] = ord(substr($info_data[5], -2, 1));
				$this->getInfo["_version"] = ord(substr($info_data[5], -1, 1));

				$server_cfg = preg_split("/\\x00/", $this->buffer_rules);
				$i=0;
				while($i < sizeof($server_cfg)){
					$this->getInfo[$server_cfg[$i]] = $server_cfg[$i+1];
					$this->RulesList[] = array(0=>$server_cfg[$i], 1=>$server_cfg[$i+1]);
					$i +=2;
				}

				$this->PlayersCount = ord(substr($this->buffer_players, 0, 1));			
				$this->PlayersList = array(substr($this->buffer_players, 1));

			}else{
				$this->errmsg = "could not connect";
				return 0;
			}
		}
		
		// Return to Castle Wolfenstein, Quake3
		elseif(preg_match("/\bRTCW\b|\bQ3\b/i", $this->GameName)){
			$socket = fsockopen("udp://".gethostbyname($Host), $Port , $errno, $errstr , 3);
			@socket_set_timeout($socket, $this->Timeout);
			if($socket){
				fputs($socket, "\xff\xff\xff\xffgetstatus");
				fread($socket, 4);
				$SocStatus = socket_get_status($socket);
				$this->buffer_status = fread($socket, $SocStatus['unread_bytes']);

				fputs($socket, "\xff\xff\xff\xffgetinfo");
				fread($socket, 4);
				$SocStatus = socket_get_status($socket);
				$this->buffer_info = fread($socket, $SocStatus['unread_bytes']);

				fclose($socket);
				
				if($SocStatus["timed_out"]){
					$this->errmsg = "time out";
					return 0;
				}

				$this->buffer_status = preg_replace("/\^\d{1}/", "", $this->buffer_status);
				$lines = preg_split("/\n/" , $this->buffer_status);
			
				$this->PlayersList = array_slice ($lines, 2);
				$this->PlayersCount = sizeof($this->PlayersList);
				$this->getInfo["_players"] = count($this->PlayersList) - 1;

				$this->buffer_info = $lines[1];
				preg_match_all("/([a-zA-Z_]+\\\[^\\\]+)/", $this->buffer_info, $server_cfg);

				foreach ($server_cfg[0] as $line){
					list($name,$value) = preg_split("/\\\/", $line);
					$this->getInfo[$name] = $value;
					$this->RulesList[] = array(0=>$name, 1=>$value);
				}
				
				return 1;
			}else{
				$this->errmsg = "could not connect";
				return 0;
			}		
		}else{
			$this->errmsg = "unknown game";
			return 0;
		}
	}

	function get_players_list (){
		return new mooList($this->GameName,$this->PlayersCount,$this->PlayersList);
	}
	
	function get_rules_list (){
		return new mooList($this->GameName,count($this->RulesList),$this->RulesList);
	}
	
	function set_rcon ($ip,$port,$password){
		$this->rcon_ip = $ip;
		$this->rcon_port = $port;
		$this->rcon_pass = $password;
		
		$socket = fsockopen("udp://".gethostbyname($this->rcon_ip), $this->rcon_port , $errno, $errstr , 3);
		@socket_set_timeout($socket, $this->Timeout);
		if($socket){
			fputs($socket, "\xff\xff\xff\xffchallenge rcon");
			fread($socket, 4);
			$SocStatus = socket_get_status($socket);
			preg_match("/(\d+)/", fread($socket, $SocStatus['unread_bytes']), $match);
			$this->rcon_challenge = $match[1];
		}else{
			$this->errmsg = "could not connect";
			return 0;
		}
	}
	
	function rcon_command ($command){
		if(preg_match("/\bHL\b|\bCS\b/i", $this->GameName)){
			$command = stripslashes($command);
			$socket = fsockopen("udp://".gethostbyname($this->rcon_ip), $this->rcon_port , $errno, $errstr , 3);
			@socket_set_timeout($socket, $this->Timeout);
			if($socket){
				fputs($socket, "\xff\xff\xff\xffrcon ".$this->rcon_challenge." \"".$this->rcon_pass."\" ".$command);
				fread($socket, 5);
				$SocStatus = socket_get_status($socket);
				if(preg_match("/Bad rcon_password/i", fread($socket, $SocStatus['unread_bytes']))) {
					$this->errmsg = "Bad rcon_password";
					return 0;
				} else {
					return 1;
				}
			}else{
				$this->errmsg = "could not connect";
				return 0;
			}
		}
	}
}


// Listing class
class mooList {
	function mooList ($name,$amount,$players){
		$this->GameName = $name;
		$this->Amount = $amount;
		$this->Content = $players;
		$this->Row = array();
	}

	function list_rules(){
		if(preg_match("/\bRTCW\b|\bQ3\b|\bHL\b|\bCS\b/i", $this->GameName)){
			$this->Amount--;
			$this->Row["Rule"] = $this->Content[$this->Amount-1][0];
			$this->Row["Value"] = $this->Content[$this->Amount-1][1];

			if($this->Amount <= 0){ return 0; } else {
				return $this->Row;
			}
		}
	}

	function list_players(){
		if(preg_match("/\bHL\b|\bCS\b/i", $this->GameName)){			
			if($this->Amount <= 0){ return 0; } else {
				
				$this->Content[0] = substr($this->Content[0], 1);
				preg_match("/^(.*)\\x00/U", $this->Content[0], $matches);
				$this->Row['Player'] = $matches[1];
				$this->Content[0] = substr($this->Content[0], strlen($matches[1]));
			
				$this->Row['Frags'] = mooIEEEUnpack("i", substr($this->Content[0], 1, 4));
				$this->Row['Playtime'] = mooIEEEUnpack("f", substr($this->Content[0], 5, 4));
				$this->Content[0] = substr($this->Content[0], 9);
				$this->Amount--;
				
				return $this->Row;
			}

		}	
		elseif(preg_match("/\bRTCW\b|\bQ3\b/i", $this->GameName)){
			$this->Amount--;
			
			preg_match("/(\d+)\s+(\d+)\s+\"(.*)\"/s", $this->Content[$this->Amount-1], $player);
			$this->Row["Player"] = $player[3];
			$this->Row["Ping"] = $player[2];
			$this->Row["Frags"] = $player[1];

			if($this->Amount < 0){ return 0; } else {
				return $this->Amount;
			}
		}
	}
}


function mooIEEEUnpack($arg, $bin){
	if($arg == "i"){
		$dec = hexdec(bin2hex($bin[3].$bin[2].$bin[1].$bin[0]));
		if($dec >= 2147483647) $dec -= 4294967296 ;

		return $dec;
	}
	elseif($arg == "f"){
		$binary = decbin(hexdec(bin2hex($bin[3].$bin[2].$bin[1].$bin[0])));
		while(strlen($binary) < 32){ $binary = "0".$binary; }

		$exponent = bindec(substr($binary,1,8))-127;
		$mantisse = 1;
		$man_add = 0.5;

		for($i=9;$i<32;$i++){
			if(substr($binary, $i, 1) == '1'){ $mantisse += $man_add; }
			$man_add /= 2;
		}

		$time = round(pow(2,$exponent)*$mantisse); 
		$playtime = '';
		if ($time>3600){
			$playtime .= sprintf("%2d", $time/3600)."h ";
			$time %= 3600;
		}

		$playtime .= sprintf("%02d", $time/60)."m ";
		$time %= 60;
		$playtime .= sprintf("%02d", $time)."s";
		return $playtime;
	}
}

?>